package request

import (
	"sorbet/internal/entities"
)

type FeatureContentDetailUpsertRequest struct {
	ID         uint           `json:"id"          xml:"id"          form:"id" path:"id"`
	FeatureID  uint           `json:"feature_id"  xml:"feature_id"  form:"feature_id"`
	ChapterID  uint           `json:"chapter_id"  xml:"chapter_id"  form:"chapter_id"`
	ContentID  uint           `json:"content_id"  xml:"content_id"  form:"content_id"`
	Type       string         `json:"type"        xml:"type"        form:"type"`
	Title      string         `json:"title"       xml:"title"       form:"title"`
	Intro      string         `json:"intro"       xml:"intro"       form:"intro"`
	PosterUrl  string         `json:"poster_url"  xml:"poster_url"  form:"poster_url"`
	VideoUrl   string         `json:"video_url"   xml:"video_url"   form:"video_url"`
	Text       string         `json:"text"        xml:"text"        form:"text"`
	Attributes map[string]any `json:"attributes"  xml:"attributes"  form:"attributes"`
}

func (f *FeatureContentDetailUpsertRequest) GetID() any {
	return f.ID
}

func (f *FeatureContentDetailUpsertRequest) ToMap() map[string]any {
	return map[string]any{
		"id":         f.ID,
		"feature_id": f.FeatureID,
		"chapter_id": f.ChapterID,
		"content_id": f.ContentID,
		"type":       f.Type,
		"title":      f.Title,
		"intro":      f.Intro,
		"poster_url": f.PosterUrl,
		"video_url":  f.VideoUrl,
		"text":       f.Text,
		"attributes": f.Attributes,
	}
}

func (f *FeatureContentDetailUpsertRequest) ToEntity() any {
	return &entities.FeatureContentDetail{
		ID:         f.ID,
		FeatureID:  f.FeatureID,
		ChapterID:  &f.ChapterID,
		ContentID:  f.ContentID,
		Type:       f.Type,
		Title:      f.Title,
		Intro:      f.Intro,
		PosterUrl:  f.PosterUrl,
		VideoUrl:   f.VideoUrl,
		Text:       f.Text,
		Attributes: f.Attributes,
	}
}
