package feature

import (
	"sorbet/internal/services/feature/controller"
	"sorbet/pkg/crud"
)

type Service struct{}

func (*Service) Name() string {
	return "feature"
}

func (*Service) Priority() int {
	return 3
}

func (s *Service) Init(ctx *crud.Context) error {
	ctx.Routes(&controller.FeatureCategoryController{})
	ctx.Routes(&controller.FeatureConfigController{})
	ctx.Routes(&controller.FeatureContentChapterController{})
	ctx.Routes(&controller.FeatureContentDetailController{})
	ctx.Routes(&controller.FeatureController{})
	return nil
}

func (s *Service) Bootstrap() error { return nil }
func (s *Service) Destroy() error   { return nil }
